/*----------------------------------------------------------------------------*/
/*                                                                            */
/*      Filename:                                                             */
/*      install.cmd                                                           */
/*                                                                            */
/*      Project: AMU 3.0x installation for all AML models                     */
/*                                                                            */
/*      Description:                                                          */
/*      Installation of AMU and the environment                               */
/*      Author:                                                               */
/*      Dirk Hagenberg                                                        */
/*      History:                                                              */
/*          19. Mai 1995       -  8:21,38                                     */
/*          20. August 1998  changed DLL_BACKUP_DIRECTORY                     */
/*          04. December 1998 changed AMU-Libpath to .\DLL;                   */
/*          14. April 1999 additional copy of DDE4*.DLL                       */
/*          14. June 1999 install from CDROM possible                         */
/*          21. September 1999 installation of AMU 3.1 with DCI               */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*      (C) Copyright by ADIC/GRAU Storage System 1995 - 1999                 */
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* Definitions and variable initialisation                                    */
/*----------------------------------------------------------------------------*/
Version     = "3.10"    /* version number in the form x.xxxx ,e.g. "3.02  " */
Anz_Disks   = 5           /* number of disks for AMU                          */
Backup_Directory = "\B4_x_xx"  /* directory for previous installed AMU       */
CONFIG_SYS       = "C:\CONFIG.SYS"
CONFIG_NEW       = "C:\CONFIG.NEW"
FileName         = "AMUDISC"
AMUPATH          = "C:\AMU"
InstallLog       = "\install.log"
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
rcy = rxfuncadd('SQLDBS' , 'SQLAR','SQLDBS' );
rcy = rxfuncadd('SQLEXEC', 'SQLAR','SQLEXEC');
call SysLoadFuncs

/*----------------------------------------------------------------------------*/
/* Flags for the selection of install options                                 */
/*----------------------------------------------------------------------------*/
IniSaved      = 0               /* Flag for the saved ini file                */
QuadSupport   = 0               /* Flag for installation of Quadron software  */
PMAC          = 0               /* Flag for installation of AML/J software    */
SCSI          = 0               /* Flag for installation Scalar 1000 software */
New_Inst      = 0               /* Flag for general new installation          */
ConfigUpdate  = 0               /* Flag for Update of config.sys              */
UpdOption     = 0
Floppy_Inst   = 0               /* Installation from floppy                   */
InstError     = 0               /* Failure during installation process        */

/*----------------------------------------------------------------------------*/
/* Definition of the directories                                              */
/*----------------------------------------------------------------------------*/
Install_Directory    = directory()
Floppy_Inst          = compare(Install_Directory, 'A:\')
Backup_Directory     = overlay(Version, Backup_Directory, 5)
Backup_Directory     = overlay('_', Backup_Directory, 6)
Backup_Directory     = insert(AMUPATH,Backup_Directory)
InstallLog           = insert(AMUPATH,InstallLog)
DLL_Backup_Directory = insert(Backup_Directory,"\DLL")
CAN_Backup_Directory = insert(Backup_Directory,"\CAN")
lastbs = LASTPOS('\',Install_Directory)
inst_di_length = length(Install_Directory)
If inst_di_length = lastbs then
do
  inst_di_length = inst_di_length - 1
  Install_Directory = substr(Install_Directrory,1,inst_di_length)
end
SCSI_Install_Dir     = insert(Install_Directory,"\SCSI")

/*----------------------------------------------------------------------------*/
/*  main menu                                                                 */
/*  3 tries for selection are possible                                        */
/*----------------------------------------------------------------------------*/
'@echo off'
call LogWrite "Start of AMU Installation of version: "Version
call LogWrite "Installationdate was the "Date()
call LogWrite "AMUPATH= ["AMUPATH"]"
call LogWrite "Installation Directory= ["Install_Directory"]"
call LogWrite "Backup Directory= ["Backup_Directory"]"
do 3
  call SysCls
  say " Ŀ"
  say "               I N S T A L L A T I O N     U T I L I T Y               "
  say "                   AMU  -  V E R S I O N  " Version"                       "
  say "                   ADIC/GRAU Storage Systems                           "
  say "                                                                       "
  say "  1 = New Installation of AML Management Software                      "
  say "      (Installation without backup of an older Version)                "
  say "                                                                       "
  say "  2 = AMU Update from AMU 3.10x to AMU" Version"                           "
  say "                                                                       "
  say "  3 = AMU Update from AMU 2.30x, 2.40x or 3.0x to AMU" Version"            "
  say "                                                                       "
  say "  4 = AMU Update from AMU 2.41x to AMU" Version"                           "
  say "                                                                       "
  say "  5 = AMU Update from AMU 2.1xx or 2.2xx to AMU" Version"                  "
  say "                                                                       "
  say "  6 = AMU Update from AMU 2.0xx to AMU" Version"                           "
  say "      (Are you sure you have the correct robot software?)              "
  say "                                                                       "
  say "  7 = AMU Update from AMU 1.xxx to AMU" Version"                           "
  say "      (Are you sure you have the correct robot software?)              "
  say "                                                                       "
  say "  8 = Deinstallation (Rollback) of a previously installed AMU" Version"    "
  say "                                                                       "
  say "  9 = End                                                              "
  say "                                                                       "
  say "  Select an Option:                                                    "
  say " "
  cpos = SysCurPos(22,21)
  Option = translate(SysGetKey('NOECHO'))
  call SysCls
  say ""
  call LogWrite "Installation option is "Option

  /*---------------------------------------------------------------------------*/
  /* New Installation                                                          */
  /*---------------------------------------------------------------------------*/
  if Option = "1" then
  do
    call InstallMenu
    call NewInstall
    call Install
    if SCSI = 1 then  call InstallSCSI
    call config_update
    call AmuConf_Update
    call GoodEnd
  end

/*-----------------------------------------------------------------------------*/
/* Update from version 3.10                                                    */
/*-----------------------------------------------------------------------------*/
  if Option = "2" then
  do
    call InstallMenu
    call Update
    call Backup 1
    call Install
    copy AMUPATH"\AMUCONF.SIC "AMUPATH"\AMUCONF.INI"
    call AmuConf_Update
    DBConv
    call DataBind
    if SCSI = 1 then  call UpdateSCSI
    /* call config_update  */
    call DoThePatchesToAMUCONST
    call GoodEnd
  end

/*-----------------------------------------------------------------------------*/
/* Update from version 2.30x 2.40x 3.0x                                        */
/*-----------------------------------------------------------------------------*/
  if Option = "3" then
  do
    call InstallMenu
    call Update
    call Backup  0
    call Install
    copy AMUPATH"\AMUCONF.SIC "AMUPATH"\AMUCONF.INI"
    call AmuConf_Update
    DBConv
    call DataBind
    if SCSI = 1 then  call UpdateSCSI
    /* call config_update  */
    call DoThePatchesToAMUCONST
    call GoodEnd
  end


/*-----------------------------------------------------------------------------*/
/* Update from version 2.41                                                    */
/*-----------------------------------------------------------------------------*/
  if Option = "4" then
  do
    call InstallMenu
    call Update
    call Backup  1
    call Install
    copy AMUPATH"\AMUCONF.SIC "AMUPATH"\AMUCONF.INI"
    call AmuConf_Update
    DBConv
    call DataBind
    if SCSI = 1 then  call UpdateSCSI
    /* call config_update  */
    call DoThePatchesToAMUCONST
    call GoodEnd
  end


/*-----------------------------------------------------------------------------*/
/* Update from version 2.10x or 2.20x                                          */
/*-----------------------------------------------------------------------------*/
  if Option = "5" then
  do
    call InstallMenu
    call Update
    call Backup  0
    call Install
    copy AMUPATH"\AMUCONF.SIC "AMUPATH"\AMUCONF.INI"
    call AmuConf_Update
    DBconv
    call DataBind
    call DoThePatchesToAMUCONST
    call GoodEnd
  end

/*-----------------------------------------------------------------------------*/
/* Update from version 2.00x                                                   */
/*-----------------------------------------------------------------------------*/
  if Option = "6" then
  do
    UpdOption = 1
    call InstallMenu
    call Update
    call Backup  2
    call Install
    call IniPrep
    copy AMUPATH"\AMUCONF.BAS "AMUPATH"\AMUCONF.INI"
    INI2CONF
    DBConv
    call DataBind
    call AmuConf_Update
    call DoThePatchesToAMUCONST
    call GoodEnd
  end

/*-----------------------------------------------------------------------------*/
/* Update from version 1.0x                                                    */
/*-----------------------------------------------------------------------------*/
  if Option = "7" then
  do
    call InstallMenu
    call Update
    call Backup  2
    call Install
    call IniPrep
    copy AMUPATH"\AMUCONF.BAS "AMUPATH"\AMUCONF.INI"
    INI2CONF
    DBConv
    call DataBind
    call AmuConf_Update
    call GoodEnd
  end

/*-----------------------------------------------------------------------------*/
/* Deinstallation of the AMU                                                   */
/*-----------------------------------------------------------------------------*/
  if Option = "8" then
  do
    call Deinst
  end

/*-----------------------------------------------------------------------------*/
/* End the Program                                                             */
/*-----------------------------------------------------------------------------*/
  if Option = "9" then
  do
    exit
  end

end /* Do 3 times */
say ""
call LogWrite 'WARNING: AMU Installation ended!'
exit

/* End of main program -------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* Function:     InstallMenu                                                  */
/* Description:  Select the options for the installation                      */
/* Argument:     SelectAll                                                    */
/*----------------------------------------------------------------------------*/
InstallMenu:
do 3
  call SysCls
  say " Ŀ"
  say "               I N S T A L L A T I O N - O p t i o n s                 "
  say "                   AMU  -  V E R S I O N  " Version"                       "
  say "                                                                       "
  say "  1 = Installation without Options                                     "
  say "      (only AML/2, AML/E and AML/J)                                    "
  say "                                                                       "
  say "  2 = Installation with Drive Control Interface (DCI)                  "
  say "                                                                       "
  say "  3 = Installation with Quadron Software for RIC adapter (only AML/2)  "
  say "                                                                       "
  say "  4 = Installation with Quadron Software and DCI (only AML/2)          "
  say "      (Are you sure you have the correct robot software?)              "
  say "                                                                       "
  say "  5 = Installation for Scalar 1000                                     "
  say "                                                                       "
  say "  Select an Option:                                                    "
  say " "
  cpos = SysCurPos(22,21)
  InstType = translate(SysGetKey('NOECHO'))
  call SysCls
  say ""
  SCSI = 0
  PMAC = 0
  QuadSupport = 0
  DCI = 0

  /*---------------------------------------------------------------------------*/
  /* Installation without options                                              */
  /*---------------------------------------------------------------------------*/
  if InstType = "1" then
  do
    call LogWrite "Installation without options"
  end

  /*--------------------------------------------------------------------------*/
  /* Installation with DCI                                                    */
  /*--------------------------------------------------------------------------*/
  if InstType = "2" then
  do
    call LogWrite "Installation with DCI"
    DCI = 1
  end

  /*--------------------------------------------------------------------------*/
  /* Installation with Quadron support                                        */
  /*--------------------------------------------------------------------------*/
  if InstType = "3" then
  do
    call LogWrite "Installation with Quadron software"
    QuadSupport = 1
  end

  /*--------------------------------------------------------------------------*/
  /* Installation with Quadron and DCI                                        */
  /*--------------------------------------------------------------------------*/
  if InstType = "4" then
  do
    call LogWrite "Installation with Quadron and DCI"
    DCI = 1
    QuadSupport =1
  end

  /*---------------------------------------------------------------------------*/
  /* Installation for Scalar 1000                                              */
  /*---------------------------------------------------------------------------*/
  if InstType = "5" then
  do
    call LogWrite "Installation of Scalar 1000"
    SCSI = 1
  end
return

/*----------------------------------------------------------------------------*/
/* Function:     NewInstall                                                  */
/* Description:  Prepare for new installation of AMU                          */
/*                                                                            */
/*----------------------------------------------------------------------------*/
NewInstall:
do
  /* cls */
  New_Inst = 1
  curdir = directory(AMUPATH)
  Act_AMUPATH = stream('AMUCONF.INI', 'c', 'query exists')
  if Act_AMUPATH \= "" then  /* AMUCONF.INI exits in any directory */
  do
        call LogWrite 'INFO: There are already AMU configuration files on harddisk'
    call LogWrite 'With a new installation all configuration files will overwrited or deleted'
    if AnswerYN('Would you install a New AMU anyway? (Y/N)') = 'N' then
      SIGNAL Ende
    else
      call LogWrite 'INFO: New Installation without updated of existing AMU software.'
  end
  curdir = directory()
  call CreateDir AMUPATH
  del AMUPATH"\*.zip 2> NUL"
  curdir = directory(AMUPATH)
  DLL_Path = Insert(AMUPATH,"\DLL")
  call CreateDir DLL_Path
  curdir = directory(AMUPATH)
  CAN_Path = Insert(AMUPATH,"\CAN")
  call CreateDir CAN_Path
  curdir = directory(AMUPATH)
end
return

/*----------------------------------------------------------------------------*/
/* Function:     Update                                                       */
/* Description:  Update of previous AMU                                       */
/* Argument:     Option                                                       */
/*----------------------------------------------------------------------------*/
Update:
do
  cls
  say ""
  call LogWrite 'INFO: Installation Update for AML Management Software-Fix AMU 'Version
  curdir = directory()
  newdir = directory(AMUPATH)
  if newdir = AMUPATH then
    call LogWrite 'INFO: Successfully changed to the AMU directory'
  else
  do
    call LogWrite 'ERROR: AMU directory 'AMUPATH' not found'
    SIGNAL Ende
  end
end
return

/*----------------------------------------------------------------------------*/
/* Function:     Deinst                                                       */
/* Description:  Deinstallation of AMU update...                              */
/*                                                                            */
/*----------------------------------------------------------------------------*/
Deinst:
do
  /* cls */
  curdir = directory()
  newdir = directory(AMUPATH)
  call LogWrite 'INFO: Deinstallation of previously installed AMU AMU 'Version
  copy Backup_Directory "."
  if rc = 0 then
  call LogWrite 'the files from directory 'Backup_Directory' was succesful copied back to the AMU directory'
  else
  do
    call LogWrite 'ERROR: Rollback failed,rc='rc
    SIGNAL Ende
    return
  end
   copy DLL_Backup_Directory "DLL"
  if rc = 0 then
  call LogWrite 'the files from directory 'DLL_Backup_Directory' was succesful copied back to the AMU directory'
  else
  do
    call LogWrite 'ERROR: Rollback failed,rc='rc
    SIGNAL Ende
    return
  end
  copy CAN_Backup_Directory "CAN"
  if rc = 0 then
  call LogWrite 'the files from directory 'CAN_Backup_Directory' was succesful copied back to the AMU directory'
  else
    call LogWrite 'INFO: no Rollback of CAN files (Perhaps installation without DCI),rc='rc
  call LogWrite ""
  call LogWrite "INFO: Deleting the AMU Backup Directories"
  call SysRmDir DLL_Backup_Directory
  call SysRmDir CAN_Backup_Directory
  call SysRmDir Backup_Directory
  copy AMUPATH'\AMUCONF.SIC 'AMUPATH'\AMUCONF.INI'
  call DataBind
  If InstError = 1 then
    SIGNAL Ende
  else
    call GoodEnd
end
return

/*----------------------------------------------------------------------------*/
/* Function:     Ende                                                         */
/* Description:  Abnormal end of installation program                         */
/*                                                                            */
/*----------------------------------------------------------------------------*/
Ende:
do
  call LogWrite '        The Installation scripts is stopped because of user request'
  call LogWrite '        or because of failure'
  call LogWrite "        The Installation procedure was not yet completed"
  call LogWrite '        Unsuccessful end of installation!!!'
  say ""
  newdir = directory(curdir)
end
exit

/*----------------------------------------------------------------------------*/
/* Function:     Backup                                                       */
/* Description:  Backup of current of AMU                                     */
/*                                                                            */
/*----------------------------------------------------------------------------*/
Backup:
parse arg BackupOpt
do
  fspec = SysSearchPath('AMUPATH', 'Krn.exe')
  if fspec = ''
  then
  do
    call LogWrite 'ERROR: Something is wrong with the AMUPATH Environment'
    SIGNAL Ende
  end
  /* AMU Database Backup */
  call GetDBName
  call LogWrite 'Database' DBName 'will be saved, please wait'
  startdbm
  'db2 BACKUP DATABASE 'DBName' TO C'
  If rc = 0 then
    call LogWrite 'Database Backup was successful'
  else
    call LogWrite 'Database was not saved!'
  /* Prepare the Backup directories */
  curdir = directory()
  call CreateDir Backup_Directory
  curdir = directory(Backup_Directory)
  call CreateDir DLL_Backup_Directory
  curdir = directory(Backup_Directory)
  call CreateDir CAN_BACKUP_Directory
  curdir = directory(AMUPATH)
  /* cleaning directory from *.out-files */
  del '*.out 2> NUL'
  if rc = 0 then
    call LogWrite 'INFO: All out.files deleted'
  else
    call LogWrite 'INFO: No out.files found to delete: That is o.k!'
  /* Saving AMU files */
  call LogWrite 'INFO: Start saving AMU-directory ...'
  copy "." Backup_Directory
  if rc = 0 then
    call LogWrite 'INFO: files from AMU directory was saved'
  else
    call LogWrite 'INFO: Some files from AMU directory could not be saved'
  call LogWrite 'INFO: Trying to delete old ZIP Files ... '
  del AMUPATH'\*.zip 2> NUL'
  call LogWrite 'INFO: Start saving AMU\DLL directory ...'
  copy "DLL\*" DLL_Backup_Directory
  if rc = 0 then
    call LogWrite 'INFO: files from AMU\DLL directory was saved'
  else
    call LogWrite 'INFO: Some files from AMU\DLL could not be saved'
  If BackupOpt = 1  then
  do
    call LogWrite 'INFO: Start saving AMU\CAN directory ...'
    copy "CAN\*" DLL_Backup_Directory
    if rc = 0 then
      call LogWrite 'INFO: files from AMU\CAN directory was saved'
    else
    do
      call LogWrite 'INFO: Some files from AMU\CAN could not be saved'
      call LogWrite ' Maybe Installation before was without DCI'
    end
  end
  If BackupOpt = 2 then
  do
    copy AMUPATH'\AMUINI.INI' AMUPATH'\AMUINI.SIC'
    if rc = 0 then
      call LogWrite "INFO: AMUINI.INI was saved"
    else
      call LogWrite "ERROR: AMUINI.INI was not found."
  end
  else
  do
    call LogWrite 'INFO: AMUCONF.INI will be copied to AMUCONF.SIC'
    copy AMUPATH'\AMUCONF.INI 'AMUPATH'\AMUCONF.SIC'
  end
end
return

/*----------------------------------------------------------------------------*/
/* Function:     Install                                                      */
/* Description:  Installation of new AMU                                      */
/*                                                                            */
/*----------------------------------------------------------------------------*/
Install:
do
  Zipper_Found = 0
  if Floppy_Inst = 0 then
  do
    DiskNumber = 1
    do Anz_Disks
      say ''
      File = 'a:\*'DiskNumber'.zip'
      if DiskNumber > 1 then call DiskRequest File DiskNumber
      say ""
      call LogWrite 'INFO: Copying from installation disk ...'
      copy 'a:\AMU*.zip 'AMUPATH
      if rc = 0 then
        call LogWrite 'INFO: Diskette 'DiskNumber' successful copied to harddisk'
      else
      do
        call LogWrite 'ERROR: Diskette does not contain AMU Diskette 'DiskNumber'. Installation is stopped!'
        SIGNAL Deinst
      end
      if Zipper_Found = 0 then
      do
        copy 'a:\unzip.exe 'AMUPATH
        if rc = 0 then
        do
          call LogWrite 'INFO: extract program was founded'
          Zipper_Found = 1
        end
      end
      DiskNumber = DiskNumber + 1
    end
  end /* end of floppy installation */
  else /* begin CDROM installation */
    do
    say ""
    call LogWrite 'INFO: Copy the AMU to harddisk ...'
    DiskNumber = 1
    do Anz_Disks
      ZipFile = Overlay(DiskNumber,FileName,8)
      call LogWrite 'copy the file 'ZipFile'.zip to the directory 'AMUPATH
      copy Install_Directory'\'ZipFile'.ZIP' AMUPATH
      if rc = 0 then
        call LogWrite 'INFO: AMU file ' DiskNumber ' successful copied to harddisk'
      else
      do
        call LogWrite 'ERROR: Directory does not contain correct AMU software. Installation is stopped!'
        InstError = 1
        SIGNAL Deinst
      end
      if Zipper_Found = 0 then
      do
        copy Install_Directory'\unzip.exe' AMUPATH
        if rc = 0 then
        do
          call LogWrite 'INFO: extract program was founded'
          Zipper_Found = 1
        end
      end /* search unzip program */
    DiskNumber = DiskNumber + 1
    end   /* search AMU zip files */
  end     /* CDROM installation */
  call LogWrite 'INFO: Start extracting new AMU ...'
  DiskNumber = 1
  actdir = directory()
  call LogWrite 'The installation starts in the directory:'actdir
  do Anz_Disks
    ZipFile = Overlay(DiskNumber,FileName,8)
    call LogWrite ' INFO: extract 'ZipFile'.zip'
    unzip '-o 'ZipFile'.zip'
    if rc = 0 then
     call LogWrite 'INFO: Software successful extracted'
    else
    do
      if rc = 1 then
      do
        call LogWrite "ERROR: Some files could not be extracted"
        InstError = 1
        SIGNAL Deinst
      end
      else
        SIGNAL NoUnzip
    end
    DiskNumber = DiskNumber + 1
  end
  copy "*.dll DLL"
  if rc = 0 then
    call LogWrite 'INFO: Dynamic Link Libraries copied successful to directory DLL'
  else
  do
    call LogWrite ' ERROR: Some files could not be copied to directory DLL,'
    call LogWrite '        Retry, but make sure, that no program is runnig or write protected in 'AMUPATH'\DLL.'
    InstError = 1
    SIGNAL Deinst
  end
  del '*.dll 2> NUL'
  /* copy dci software into CAN directory */
  copy "*.ac CAN"
  del '*.ac  2> NUL'
  copy "dl.bat CAN"
  del 'dl.bat 2> NUL'
  copy "E_DldPC.exe CAN"
  del 'E_DldPC.exe 2>NUL'
  copy "CANDRV.SYS CAN"
  del 'CANDRV.SYS 2>NUL'
  call LogWrite 'INFO: CAN support copied to harddisk'
  if New_Inst = 1 then
    copy "C:\AMU\AMUCONF.BAS C:\AMU\AMUCONF.INI"
end
return

/*----------------------------------------------------------------------------*/
/* Function:     AmuConf_Update                                               */
/* Description:  Changed parameters in the file AMUCONF.INI                   */
/*                                                                            */
/*----------------------------------------------------------------------------*/
AmuConf_Update:
do
  call LogWrite 'INFO: Updating Version String'
  patstr = "PROC VERSION V0xxxx"
  patstr = overlay(Version, patstr, 16)
  patini patstr
/*  If RC = 0 then
    call LogWrite "Versionsring updated successful"
  else
    call LogWrite "ERROR during update of the Version string.rc="rc */
  call LogWrite "INFO: Udating Kernel Load Modules"
  File = AMUPATH"\AMUCONF.ini"
  KrnLoad = sysini(File,"PROC","KRNLOAD")
  Call LogWrite "The actual Kernel Load Modules are: "KrnLoad
  If KrnLoad <> 'ERROR:' then
  do
    rc= POS("KNP",KrnLoad)
    if rc = 0 then
    do
      call LogWrite "To the actual Load Modules [" KrnLoad"] KNP (Kernel/P) will be added"
      patstr = Insert("PROC KRNLOAD ""KNP ",KrnLoad)
      patstr = Insert(patstr,"""")
      call LogWrite "The new Load list is: ["patstr"]"
    end
    else
    do
      call Logwrite "The actual KRNLOAD list is ok"
      return
    end
  end
  else
  do
    call LogWrite "No actual AMUCONF.INI in the directory, use default load modules KNP UPM HOC ARC"
    patstr = "PROC KRNLOAD ""KNP UPM HOC ARC"""
  end
  call LogWrite "INFO: Loadlist update with:"patstr
  patini patstr
end
return

/*----------------------------------------------------------------------------*/
/* Function:     DataBind                                                     */
/* Description:  Link database to AMU                                         */
/*                                                                            */
/*----------------------------------------------------------------------------*/
DataBind:
do
  logoff
  call LogWrite "INFO: Binding for the ARC modules"
  call GetDBName
  call LogWrite 'Binding of the Arc modules for Database 'DBName
  startdbm
  'db2 CONNECT TO 'DBName
  If rc = 0 then
    call LogWrite 'Database Connection established'
  else
    call LogWrite 'Database not connected, perhaps database does not exist.rc=' rc
  'db2 RUNSTATS ON TABLE AMU.POOL'
    If rc = 0 then
    call LogWrite 'runstats of table POOL was ok'
  else
    call LogWrite 'runstats of POOL failed, perhaps database does not exist.rc=' rc
  'db2 DBM RUNSTATS ON TABLE AMU.COORDINATES'
    If rc = 0 then
    call LogWrite 'runstats of table COORDINATES was ok'
  else
    call LogWrite 'runstats of COORDINATES failed, perhaps database does not exist.rc=' rc
  'db2 DBM RUNSTATS ON TABLE AMU.SCOORDINATES'
    If rc = 0 then
    call LogWrite 'runstats of table SCOORDINATES was ok'
  else
    call LogWrite 'runstats of SCOORDINATES failed, perhaps database does not exist.rc=' rc
  'db2 connect reset'
  if rc = 0 then
    call LogWrite 'database connection reset was ok'
  else
    call LogWrite 'database connection reset failed.rc=' rc
  'SQLBIND ArcBack.BND  'DBName' /F=EUR'
  if rc = 0 then
    call LogWrite 'sqlbind for ArcBack was ok'
  else
    call LogWrite 'sqlbind for ArcBack failed.rc=' rc
  'SQLBIND ArcSQLe.BND  'DBName' /F=EUR'
  if rc = 0 then
    call LogWrite 'sqlbind for ArcSQLe was ok'
  else
    call LogWrite 'sqlbind for ArcSQLe failed.rc=' rc
  'SQLBIND ArcSQLeN.BND 'DBNAme' /F=EUR'
  if rc = 0 then
    call LogWrite 'sqlbind for ArcSQLeN was ok'
  else
    call LogWrite 'sqlbind for ArcSQLeN failed.rc=' rc
  'SQLBIND ArcBSQL.BND  'DBName' /F=EUR'
  if rc = 0 then
    call LogWrite 'sqlbind for ArcBSql was ok'
  else
    call LogWrite 'sqlbind for ArcBSql failed.rc=' rc
end
return

/*----------------------------------------------------------------------------*/
/* Function:     IniPrep                                                      */
/* Description:  Prepare the INI files                                        */
/*                                                                            */
/*----------------------------------------------------------------------------*/
IniPrep:
do
  attrib 'AMUINI.INI -r'
  if  UpdOption = 1 then
    call LogWrite "INFO: Updating INI-entries from AMU2.xxx to AMU2.00G"
  else
    call LogWrite "INFO: Updating INI-entries from AMU1.xxx to AMU2.00G"
  call LogWrite 'INFO: Start updating INI-Files ...'
  call KrnPset.cmd
end
return

/*----------------------------------------------------------------------------*/
/* Function:     GoodEnd                                                      */
/* Description:  Normal End of Installatio program                            */
/*                                                                            */
/*----------------------------------------------------------------------------*/
GoodEnd:
do
  newdir = directory("C:/")
  if ConfigUpdate = 1 then
  do
    r = stream(CONFIG_NEW, 'c', 'close')
    copy CONFIG_NEW CONFIG_SYS
    del CONFIG_NEW
  end
  cls
  say ""
  call LogWrite 'End of AML Management Software Installation'
  call LogWrite 'Installation was succcessful'
  say ""
  if SCSI = 0 then
  do
    say ""
    call LogWrite 'Are you sure you have the latest AML/2, AML/E or AML/J Robot Software'
    call LogWrite 'installed? Call Service to inquire about the latest release!'
  end
  if ConfigUpdate = 1 then
  do
    say ""
    call LogWrite 'Your CONFIG.SYS was updated.'
    call LogWrite 'To activate the changes, you need to reboot the AMU.'
  end
  say ""
end
exit

/*----------------------------------------------------------------------------*/
/* Function:     NoUnzip                                                      */
/* Description:  Error message because of missing pkunzip                     */
/*                                                                            */
/*----------------------------------------------------------------------------*/
NoUnzip:
do
  call LogWrite "ERROR: UNZIP.EXE program not found or did not work correctly."
  call LogWrite "ERROR: Try to get a copy of UNZIP.EXE. Copy it to C:\AMU and"
  call LogWrite "ERROR: type UNZIP -o AMUxxxx.ZIP in an os/2 window."
  SIGNAL RollBack
end

/*----------------------------------------------------------------------------*/
/* Function:     config_update                                                */
/* Description:  change the file config.sys                                   */
/*                                                                            */
/*----------------------------------------------------------------------------*/
config_update:
do
  LibPathUpdt = 0
  PathUpdt    = 0
  ret         = 1
  actdir =directory('c:\')
  call LogWrite 'INFO: Saving the current CONFIG.SYS file'
  copy  CONFIG_SYS "c:\config.B4A"
  if rc > 0 then
  do
    say ""
    call LogWrite 'Attention: a backup of your config.sys already exists'
    call LogWrite 'and it is already write protected!'
    call LogWrite 'Do you still want to make a backup of the file'
    if AnswerYN('CONFIG.SYS into the file CONFIG.B4A?  (Y/N)') = 'Y' then
    do
      attrib 'c:\config.B4A -r'
      copy  CONFIG_SYS "c:\config.B4A"
      attrib 'c:\config.B4A +r'
      call LogWrite 'INFO: Backup of CONFIG.SYS written to CONFIG.B4A'
      call LogWrite '      and set to read only.'
    end
    else
      call LogWrite 'INFO: No new backup of CONFIG.SYS was written to CONFIG.B4A!'
  end
  else
  do
    call LogWrite 'INFO: Trying to protect the backup config.sys (CONFIG.B4A)'
    call LogWrite '      from being overwritten'
    attrib 'c:\config.B4A +r'
  end
  say ''
  /*--------------------------------------------------------------------------*/
  /*  Check of LIBPATH, PATH and AMUPATH                                      */
  /*--------------------------------------------------------------------------*/
  i = linein(CONFIG_NEW,1,0)

  LibPathUpdt   = 0
  PathUpdt      = 0
  AmuPathSet    = 0
  ScsiDriverSet = 0
  DmdSet        = 0
  AddSet        = 0
  QPathSet      = 0
  CANDriverSet  = 0
  ret = 1

  do while ret = 1
    DoneAline  = 0
    aline = linein(CONFIG_SYS)

    /*------------------------------------------------------------------------*/
    /*  Set LIBPATH for AMU                                                   */
    /*------------------------------------------------------------------------*/
    if LibPathUpdt = 0 then
    do
      i = compare('LIBPATH',aline)
      if i >= 8 then
      do
        p = pos(".\DLL;",aline)
        if p = 0 then
        do
          call LogWrite 'INFO: LIBPATH for AMU not found'
          i = length(aline)
          c = substr(aline, i, 1)
          do
            newline = insert( ".\DLL;", aline, 8 )
            call LogWrite 'INFO: LIBPATH  for AMU added'
          end
          i = lineout(CONFIG_NEW, newline)
          DoneAline = 1
          LibPathUpdt = 1
        end
        else
        do
          call LogWrite 'INFO: LIBPATH  for AMU already exists'
        end
      end
    end
    /*------------------------------------------------------------------------*/
    /*  Check of PATH for Quadron                                             */
    /*------------------------------------------------------------------------*/
    if DoneAline = 0 then
    do
      if QuadSupport = 1 then
      do
        if PathUpdt = 0 then
        do
          i = compare('SET PATH',aline)
          if i >= 9 then
          do
            p = pos("C:\QCF\OS2EXE;",aline)
            if p = 0 then
            do
              call LogWrite 'INFO: PATH for Quadron not found'
              i = length(aline)
              c = substr(aline, i, 1)
              if c = ';' then
              do
                newline = insert( "C:\QCF\OS2EXE;", aline, i )
                call LogWrite 'INFO: PATH for Quadron added'
              end
              else
              do
                newline = insert( ";C:\QCF\OS2EXE;", aline, i )
                call LogWrite 'INFO: PATH for Quadron added'
              end
              i = lineout(CONFIG_NEW, newline)
              DoneAline = 1
              PathUpdt = 1
            end
            else
               call LogWrite 'INFO: PATH for Quadron already exists'
          end
        end
      end
    end
    /*--------------------------------------------------------------------------*/
    /*  Check of HELPPATH                                                       */
    /*--------------------------------------------------------------------------*/
    if DoneAline = 0 then
    do
      i = compare('SET HELP=',aline)
      if i >= 10 then
      do
        p = pos("C:\AMU;",aline)
        if p = 0 then
        do
          call LogWrite 'INFO: HELP path for AMU not found'
          i = length(aline)
          c = substr(aline, i, 1)
          if c = ';' then
          do
            newline = insert( "C:\AMU;", aline, i )
            call LogWrite 'INFO: HELP path for AMU added'
          end
          else
          do
            newline = insert( ";C:\AMU;", aline, i )
            call LogWrite 'INFO: HELP path for AMU added'
          end
          i = lineout(CONFIG_NEW, newline)
          DoneAline = 1
        end
        else
        do
          call LogWrite 'INFO: HELP path for AMU already exists'
        end
      end
    end

    /*--------------------------------------------------------------------------*/
    /*  Default for unchanged lines                                             */
    /*--------------------------------------------------------------------------*/
    if DoneAline = 0 then
    do
      i = lineout(CONFIG_NEW, aline)
    end

    /*--------------------------------------------------------------------------*/
    /*  Check of AMUPATH                                                        */
    /*--------------------------------------------------------------------------*/
    if DoneAline = 0 & AmuPathSet = 0 then
    do
      i = compare('SET AMUPATH',aline)
      if i >= 12 then
      do
        AmuPathSet = 1
        call LogWrite 'INFO: AMUPATH already exists'
      end
    end

    /*--------------------------------------------------------------------------*/
    /*  Check of QPATH for Quadron                                              */
    /*--------------------------------------------------------------------------*/
    if DoneAline = 0 & QPathSet = 0 then
    do
      i = compare('SET QPATH',aline)
      if i >= 10 then
      do
        QPathSet = 1
        call LogWrite 'INFO: QPATH already exists'
      end
    end

    /*--------------------------------------------------------------------*/
    /*  Check of SCSI driver settings                                     */
    /*--------------------------------------------------------------------*/
    if DoneAline = 0 then
    do
      if SCSI = 1 then
      do
        if ScsiDriverSet = 0 then
        do
          i = compare('DEVICE=C:\AMU\SCSI\AMLS.',aline)
          if i >= 25 then
          do
            ScsiDriverSet = 1
            call LogWrite 'INFO: SCSI driver path already exists'
          end
        end
        if DmdSet = 0 then
        do
          i = compare('BASEDEV=OS2SCSI.',aline)
          if i >= 17 then
          do
            DmdSet = 1
            call LogWrite 'INFO: Device Manager Driver path already exists'
          end
        end
        if AddSet = 0 then
        do
          i = compare('BASEDEV=AIC7870.',aline)
          if i >= 17 then
          do
            AddSet = 1
            call LogWrite 'INFO: Adapter Device Driver path already exists'
          end
        end
      end
    end
    /*--------------------------------------------------------------------*/
    /*  Check of CAN driver settings                                      */
    /*--------------------------------------------------------------------*/
    if DoneAline = 0 then
    do
      if DCI = 1 then
      do
        if CANDriverSet = 0 then
        do
          i = compare('DEVICE=C:\AMU\CAN\CANDRV.SYS',aline)
          if i = 0 then
          do
            CANDriverSet = 1
            call LogWrite 'INFO: CAN driver path already exists'
          end
        end
      end
    end
    ret = lines(CONFIG_SYS)
  end
  i = lineout(CONFIG_SYS)
  call file_close CONFIG_SYS
  /*--------------------------------------------------------------------------*/
  /*  set the AMUPATH                                                         */
  /*--------------------------------------------------------------------------*/
  if AmuPathSet = 0 then
  do
    i = lineout(CONFIG_NEW, "SET AMUPATH=C:\AMU")
    call LogWrite 'INFO: AMUPATH added'
  end
  /*--------------------------------------------------------------------------*/
  /*  set the SCSI driver                                                     */
  /*--------------------------------------------------------------------------*/
  if SCSI = 1 then
  do
    if ScsiDriverSet = 0 then
    do
      i = lineout(CONFIG_NEW, "DEVICE=C:\AMU\SCSI\AMLS.SYS")
      call LogWrite 'INFO: SCSI driver statement added'
    end
    if DmdSet = 0 then
    do
      i = lineout(CONFIG_NEW, "BASEDEV=OS2SCSI.DMD")
      call LogWrite 'INFO: Device Manager Driver statement added'
    end
    if AddSet = 0 then
    do
      i = lineout(CONFIG_NEW, "BASEDEV=AIC7870.ADD")
      call LogWrite 'INFO: Adapter Device Driver statement added'
    end
  end
  /*--------------------------------------------------------------------------*/
  /*  set the CAN driver                                                     */
  /*--------------------------------------------------------------------------*/
  if DCI = 1 then
  do
    if CANDriverSet = 0 then
    do
      i = lineout(CONFIG_NEW, "DEVICE=C:\AMU\CAN\CANDRV.SYS")
      call LogWrite 'INFO: CAN driver statement added'
    end
  end
  /*--------------------------------------------------------------------------*/
  /*  set the Quadron support                                                 */
  /*--------------------------------------------------------------------------*/
  if QuadSupport = 1 & QPathSet = 0 then
  do
    i = lineout(CONFIG_NEW, "SET QPATH=C:\QCF\RICEXE;C:\QCF\OS2EXE")
    i = lineout(CONFIG_NEW, "DEVICE=C:\QCF\OS2EXE\QCFDEV.SYS C:\QCF\OS2EXE\QPARM.PRM")
    i = lineout(CONFIG_NEW, "DEVICE=C:\QCF\OS2EXE\QCOMDEV.SYS C:\QCF\OS2EXE\QCOMPARM.PRM")
    call file_close CONFIG_NEW
    call LogWrite 'INFO: QPATH and device drivers for Quadron added'
    call SysFileSearch 'QRESET 0', 'C:\STARTUP.CMD', stamm.
    if stamm.0 = 0 | RESULT = 3 then
    do
      call LogWrite 'INFO: Writing Quadron Initialization into STARTUP.CMD'
      i = lineout("C:\STARTUP.CMD", "CD \qcf\os2exe ")
      i = lineout("C:\STARTUP.CMD", "REM *** RESET THE RIC CARD 0 *** ")
      i = lineout("C:\STARTUP.CMD", "QRESET 0")
      i = lineout("C:\STARTUP.CMD", "REM *** LOAD REALTIME CONTROL MICROCODE *** ")
      i = lineout("C:\STARTUP.CMD", "REM ***      512KB RIC cards only       *** ")
      i = lineout("C:\STARTUP.CMD", "REM ***      Rem out for 1MB RIC cards  *** ")
      i = lineout("C:\STARTUP.CMD", "QLD ICAAIM.COM /C0")
      i = lineout("C:\STARTUP.CMD", "REM *** LOAD qCOM ON RIC 0 AS TASK 2 *** ")
      i = lineout("C:\STARTUP.CMD", "QCOMLOAD 0 2")
    end
    else
    do
       call LogWrite 'ERROR: Cannot write Quadron Initialization into STARTUP.CMD'
    end
  end
  call WriteStartup 'C:\STARTUP.CMD'
  ConfigUpdate = 1
end
return

/*----------------------------------------------------------------------------*/
/* Function:     InstallSCSI                                                  */
/* Description:  install Scalar 1000 support                                  */
/*                                                                            */
/*----------------------------------------------------------------------------*/
InstallSCSI:
do
  say ""
  if AnswerYN('Would you like to copy Scalar 1000 SCSI software? (Y/N)') = 'Y' then
  do
    /*** Create SCSI directory ***/
    newdir = directory("C:/AMU")
    if newdir = "C:\AMU" then
    do
      rc = SysMkDir('SCSI')
      if rc = 0 then
      do
        call LogWrite 'INFO: SCSI directory successfully created'
        newdir = directory("C:/AMU/SCSI")
      end
      else
      do
        call LogWrite 'ERROR: SCSI directory could not be created!'
      end
    end
    /*** Copy the Files to the locations ***/
    if Floppy_Inst = 0 then
    do
      File = 'A:\AMLS.SYS'
      DiskName = 1 '(SCSI Software)'
      call DiskRequest File DiskName
      say ""
      call LogWrite 'INFO: Copying from SCSI disk ...'
      copy 'A:\AMLS.SYS' 'C:\AMU\SCSI'
      if rc = 0 then
      do
        copy 'A:\*.exe' 'C:\AMU\SCSI'
        copy 'A:\*.dll' 'C:\AMU\SCSI'
        copy 'A:\*.hlp' 'C:\AMU\SCSI'
        copy 'A:\*.ICO' 'C:\AMU\SCSI'
        call LogWrite 'INFO: Scalar 1000 driver successful copied'
      end
      else
      do
        call LogWrite 'ERROR: Diskette did not contain Scalar 1000 device driver!'
        call LogWrite 'ERROR: The installation is stopped!'
        SIGNAL Ende
      end
    end
    else
    do
      say ""
      call LogWrite 'INFO: Copying SCSI files to harddisk ...'
      copy SCSI_Install_Dir'\AMLS.SYS' 'C:\AMU\SCSI'
      if rc = 0 then
      do
        copy SCSI_Install_Dir'\*.exe' 'C:\AMU\SCSI'
        copy SCSI_Install_Dir'\*.dll' 'C:\AMU\SCSI'
        copy SCSI_Install_Dir'\*.hlp' 'C:\AMU\SCSI'
        copy SCSI_Install_Dir'\*.ICO' 'C:\AMU\SCSI'
        call LogWrite 'INFO: Scalar 1000 driver successful copied'
      end
      else
      do
        call LogWrite 'ERROR: Diskette did not contain Scalar 1000 device driver!'
        call LogWrite 'ERROR: The installation is stopped!'
        SIGNAL Ende
      end
    end
  end
end
return

/*----------------------------------------------------------------------------*/
/* Function:     UpdateSCSI                                                   */
/* Description:  update Scalar 1000 software                                        */
/*                                                                            */
/*----------------------------------------------------------------------------*/
UpdateSCSI:
do
say ""
if AnswerYN('Would you like to copy Scalar 1000 SCSI software? (Y/N)') = 'Y' then
do
  File = 'A:\AMLS.SYS'
  DiskName = 1 '(SCSI Software)'
  SCSI_DA = 1
  newdir = directory("C:/AMU/SCSI")
  if newdir = "C:\AMU\SCSI" then
  do
    rc = SysMkDir('BACKUP')
    newdir = directory("C:/AMU/SCSI/BACKUP")
    if newdir = "C:\AMU\SCSI\BACKUP" then
    do
      call LogWrite 'INFO: Saving SCSI files to BACKUP directory'
      xcopy 'C:\AMU\SCSI\*.*' 'C:\AMU\SCSI\BACKUP'
    end
    else
    do
      call LogWrite 'ERROR: SCSI device driver could not be saved!!'
      call LogWrite 'ERROR: Scalar 1000 SCSI software will not be copied!'
      SCSI_DA = 0
    end
  end
  else
  do
    call LogWrite 'ERROR: SCSI directory does not exist!!'
    call LogWrite 'ERROR: This is correct if this AMU does not support an Scalar 1000!'
    call LogWrite 'ERROR: Scalar 1000 SCSI software will not be copied!'
    SCSI_DA = 0
  end
  if SCSI_DA = 1 then
  do
    newdir = directory("C:/AMU/SCSI")
    if Floppy_Inst = 0 then
    do
      call DiskRequest File DiskName
      call LogWrite 'INFO: Copying from SCSI disk...'
      copy 'A:\AMLS.SYS' 'C:\AMU\SCSI'
      if rc = 0 then
      do
        copy 'A:\*.exe' 'C:\AMU\SCSI'
        copy 'A:\*.dll' 'C:\AMU\SCSI'
        copy 'A:\*.hlp' 'C:\AMU\SCSI'
        copy 'A:\*.ico' 'C:\AMU\SCSI'
        call LogWrite 'INFO: Scalar 1000 software was copied successful to harddisk'
      end
      else
      do
        call LogWrite 'ERROR: Unable to copy SCSI device driver!'
        call LogWrite 'ERROR: The installation is stopped!'
        SIGNAL Ende
      end
    end
    else
    do
      call LogWrite 'INFO: Copying SCSI software to harddisk...'
      copy SCSI_Install_Dir'\AMLS.SYS' 'C:\AMU\SCSI'
      if rc = 0 then
      do
        copy SCSI_Install_Dir'\*.exe' 'C:\AMU\SCSI'
        copy SCSI_Install_Dir'\*.dll' 'C:\AMU\SCSI'
        copy SCSI_Install_Dir'\*.hlp' 'C:\AMU\SCSI'
        copy SCSI_Install_Dir'\*.ico' 'C:\AMU\SCSI'
        call LogWrite 'INFO: Scalar 1000 software was copied successful to harddisk'
      end
      else
      do
        call LogWrite 'ERROR: Unable to copy SCSI device driver!'
        call LogWrite 'ERROR: The installation is stopped!'
        SIGNAL Ende
      end
    end
  end
end
return

/*----------------------------------------------------------------------------*/
/* Function:     DiskRequest                                                  */
/* Description:  ask operator for diskette                                    */
/* Argument:     DiskName File                                                */
/*----------------------------------------------------------------------------*/
DiskRequest:
parse arg File DiskName
do
  call LogWrite 'Please insert diskette' DiskName 'into drive A: and press <CR> !'
  DiskIsCorrect = 0
  do until DiskIsCorrect = 1
    pull answer
    call LogWrite 'INFO: Searching for file ' File
    call SysFileTree file, 'datei', 'F'
    if datei.0 = 0 then
    do
      say ''
      say 'ERROR: File was not found!'
      say '       Please ensure that diskette' DiskName
      say '       is inserted properly in drive A:. Then press <CR> !'
      DiskIsCorrect =  0
    end
    else
    do
      DiskIsCorrect =  1
      say 'INFO: File was found'
    end
  end
end
return

/*----------------------------------------------------------------------------*/
/* Function:     AnswerYN                                                     */
/* Description:  wait for operator input y/n                                  */
/* Argument: question                                                         */
/*----------------------------------------------------------------------------*/
AnswerYN:
parse arg question
do
  call LogWrite question
  AnswerIsYN = 0
  do while AnswerIsYN = 0
    parse upper pull answer
    if answer = 'Y' | answer = 'N' then
    do
      AnswerIsYN = 1
    end
    else
    do
      call LogWrite "Please enter only Y or N then (CR)"
    end
  end
end
return answer

/*----------------------------------------------------------------------------*/
/* Function:     file_open                                                    */
/* Description:  Open a file                                                  */
/* Argument: file_name                                                        */
/*----------------------------------------------------------------------------*/
file_open:
parse arg file_name
r = stream(file_name, 'c', 'open read')
do while r = 'NOTREADY:32'
  r = stream(file_name, 'c', 'open read')
end
return r

/*----------------------------------------------------------------------------*/
/* Function:     file_close                                                   */
/* Description:  Close a file                                                 */
/* Argument: file_name                                                        */
/*----------------------------------------------------------------------------*/
file_close:
parse arg file_name
r = stream(file_name, 'c', 'close')
return r

/*----------------------------------------------------------------------------*/
/* Function:     WriteStartup                                                 */
/* Description:  Crate a AMU startup                                          */
/* Argument: FILE_TO_READ                                                     */
/*----------------------------------------------------------------------------*/
WriteStartup:
parse arg FILE_TO_READ
FILE_TO_WRITE = "write.txt"

call SysFileSearch 'START AmuStart', FILE_TO_READ, stamm. /* Search for Start CON  */
if stamm.0 = 0 | RESULT = 3 then              /* If Start Con is not omprised */
do
  call SysFileSearch 'EXIT', FILE_TO_READ, stamm.        /*  Search for Exit  */
  if stamm.0 = 0 | RESULT = 3 then                /* if EXIT is not comprised */
  do
    call LogWrite 'INFO: Writing AMU start into STARTUP.CMD'    /* append start entries */
    i = lineout(FILE_TO_READ, "CD \AMU ")
    i = lineout(FILE_TO_READ, "START AmuStart")
  end
  else
  do
    call file_close FILE_TO_READ
    del FILE_TO_WRITE ' 2> NUL'
    call file_close FILE_TO_WRITE
    ret = lines(FILE_TO_READ)                /*  while not EOF : read a line  */
    do while ret = 1
      aline = linein(FILE_TO_READ)
      i = compare('EXIT',translate(aline))    /* If line doesn't contain exit */
      if i = 0 then
      do
        call LogWrite 'INFO: Writing AMU start into STARTUP.CMD' /* write start entries */
        i = lineout(FILE_TO_WRITE, "CD \AMU ")
        i = lineout(FILE_TO_WRITE, "START AmuStart")
        i = lineout(FILE_TO_WRITE, "EXIT")          /* write exit to the file */
      end
      else
      do
        i = lineout(FILE_TO_WRITE, aline)                  /*  write the line */
      end
      ret = lines(FILE_TO_READ)                                 /*  end while */
    end
    call file_close FILE_TO_WRITE                           /***  close ouput */
    call file_close FILE_TO_READ                            /***  close input */
    copy FILE_TO_WRITE FILE_TO_READ
  end
end
return

/*----------------------------------------------------------------------------*/
/* Function:     DoThePatchesToAMUCONST                                       */
/* Description:  Check for necessary updates of AMUCONST.INI                  */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/* Do all the patches which have been done before                             */
/*                                                                            */
/* Patches do have a "patini PATCH pat pat.cmd" line, that writes the         */
/* commandfile to be called during the update of AMU.                         */
/* So we insure, that all the patches done to the AMUCONST.INI are            */
/* done after the update installation happened.                               */
/*                                                                            */
/*                                                                            */
/*----------------------------------------------------------------------------*/
DoThePatchesToAMUCONST:
  File = "AMUCONF.ini"
  rc = sysini(File,"PATCH","ALL:","key");   /* Read of all patched lines      */
  if key.0 <> 0 then do
    do Line = 1 to key.0
      value = sysini(file,"PATCH",key.Line);   /* Read of the values in the lines */
      if value <> "" and value <> "ERROR:" then
      do
        call LogWrite "Found: "PATCH" "  key.Line": " value ".  Doing patch:"
        cmd "/c" value
      end
    end Line
  end
  else
  do
    call LogWrite "No updates in file " file " neccessary."
  end
return

/*----------------------------------------------------------------------------*/
/* Function:     GetDBName                                                    */
/* Description:  Check for the database name from AMUCONF.INI                 */
/*                                                                            */
/*----------------------------------------------------------------------------*/

GetDBName:
  File = "C:\AMU\AMUCONF.ini"
  DBName = sysini(File,"PROC","DBNAME");
  If the DBName <> 'ERROR:' then
    call LogWrite "Database Name is" DBName
  else
  do
    Say "Error in AMUCONF.INI"
    Signal ENDE
  end
  return

/*----------------------------------------------------------------------------*/
/* Function:     CreateDir                                                    */
/* Description:  Create new directories                                       */
/* Argument: directory                                                        */
/*----------------------------------------------------------------------------*/
CreateDir:
  do
  parse arg NewDir
  Ret = SysMkDir(NewDir)
    if Ret = 0 then
    do
      call LogWrite "INFO: directory "NewDir" successsful created."
      return
    end
    if Ret = 5 then
    do
      actDir = directory()
      changeDir = directory(NewDir)

      call LogWrite changeDir
      if changeDir = NewDir then
      do
        call LogWrite "INFO: Directory or file already exists"
        return
      end
      else
      do
        call LogWrite "ERROR: Directory can not be created, Perhaps a file with the name exists."
        SIGNAL Ende
        return
      end
    end
    else
    do
      call LogWrite " ERROR: Unknown error during Create of the directory, RC="RET
      SIGNAL Ende
      return
    end
  end
  return

/*----------------------------------------------------------------------------*/
/* Function:     LogWrite                                                     */
/* Description:  Logwrites and output to standard output                      */
/* Argument: text                                                             */
/*----------------------------------------------------------------------------*/
LogWrite:
  do
    parse arg text
    say text
    rc = lineout(InstallLog,text)
    call file_close InstallLog
  end
  return

/****************** end of AMU install.cmd program *************************/
